
#import <appkit/appkit.h>

@interface RECView:View {

	id		bigView;
	id		bigWindow;

	id		RECOButn;
	id 		RECLine;
	id		RECMatrix;
	id		RECOneLine;
	id		RECOneValue;
	id		RECPanel;

	id		sourceView;
	id		sourceWindow;

	id		viewView;
	id		viewWindow;

	id		browser;
	id		comment;

	id		bigBox;
	id		extBox;
	id		intBox;
	id		lilBox;

	id		demoButtons;

	id		execWin;
	id		RECValue;

	id		menuCopy;
	id		menuPrint;

	char		*filename;
	char		**filenames;
}

- ascii:sender;
- recMatrix:sender;

- loadRECPanel:sender;
- loadRECSource:sender;

- nhul:sender;
- recompile:sender;
- run:sender;
- runView:sender;
- runRECLine:sender;
- runRECOffLine:sender;
- useRECLine:sender;

- setOption:sender;

- smartPrintBigWin:sender;
- openBigWin:sender;

- close:sender;
- open:sender;
- setFilename:(const char *)aFilename;
- save:sender;
- saveAs:sender;

- copyREC:sender;
- copyAndRunREC:sender;
- copySomeView:theView;

@end

/* end RECView.h */
