
#import "rec.h"
#import "nxlcau24.h"
#import "rectbl.h"
#import  <dpsclient/psops.h>
#import  <appkit/graphics.h>

# define HZAR	   500		/* array length for graph horizons	*/

extern double r_dblpar;		/* value of REC's $xxx.yy$ */

int    RECOffset = 0;
double RECEnergy = 0.5;
double RECMass =   1.0;
double RECPoint =  0.0;
double RECPtntl[4];
double RECSolun[4];
double RECStep=0.1;
double RECPush[10];
double horhi[HZAR];
double horlo[HZAR];
double lastex, lastwy;

extern char   arule[DS], arr1[AL], arr2[AL], arr3[AL];
extern char   ttrule[TS];
extern char   strule[KK][TS-1];
extern char   cstr[CLEN];			/* console rec program */
extern char   recrule[][48];
extern char   drectabl[][HCH];
extern char   ascrule[KK][KK][KK][KK][KK][KK][KK][KK][KK];
extern int    binrule[KK][KK][KK][KK][KK][KK][KK][KK][KK];
extern int    stsum[KK];			/* state totals		     */
extern int    nhsum[KK][KK][KK][KK][KK][KK][KK][KK][KK];/* neighborhood totals	     */
extern int    rij, rdi, rdj;			/* rec demo pointers */
extern int    co, dn, dp, pa;			/* connectivity, dimension */
extern int    cp;				/* critical point          */
extern int    pr, pl;				/* rule, line prob, mils   */
extern int    bi;				/* bernstein index	   */
extern int    ct0, ct1, ct2, ct3;		/* general counters	   */
extern int    sw0, sw1, sw2, sw3;		/* general switches	   */
extern int    ex, wy;				/* hiplot coordinates	   */
extern double nu0, nu1, nu2, nu3;		/* general numeric values  */
extern double mf;				/* mouse increment	   */
extern double sm[TS];				/* selfconsistent nbrhd    */
extern double sn[TS];				/* selfconsistent nbrhd    */
extern double bx[BD];				/* bernstein factor        */
extern double bp[BD];
extern double lf[BL];				/* Life 2d gen Bern coeffs */
extern double pv[10];				/* polynomial vector 	   */
extern double fpa, fpb, fpc;			/* fixed points		   */

extern Inst   rprg[];				/* rec program array */
extern struct fptbl dtbl[];

extern long int r_intpar;
extern double   r_dblpar;

# define GROW	   12	/* row for graph panels		*/
# define BROW	    3	/* row for bar charts		*/
# define EROW	    1	/* row for evolution synopsis	*/
# define AORG 	    0	/* x-origin  of contour plot    */
# define BORG 	  109	/* x-origin  of 2-block param   */
# define CORG 	  219	/* x-origin  of Bernstein plot  */


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/*             definition of REC operators and predicates                  */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

/* ----------------------------------- */
/* rec variants of the menu operations */
/* ----------------------------------- */
/* -------------------------------------------*/
/* definition of REC operators and predicates */
/* -------------------------------------------*/

// rec(z) char *z; {if (rec_c(z,rprg,PLEN,dtbl)==1) rec_x(rprg);}

int kbint() {if (kbdst()) {kbdin(); return 0;} else return 1;}
int dpred() {if (rand()%1000>100) return 0; else return 1;}
int rpred() {if (rand()%1000>499) return 0; else return 1;}

int tilde() {prmenu();}

ropla() {asfreq(3);}
roplb() {rprob(pl);}
ropld() {diagl(*r_pc++);}
rople() {loclhden(1+ct2%3);}
roplf() {frame(*r_pc++);}
roplg() {retgen(2);}
ropli() {int i; i=nibbl(*r_pc++); piter(100,i,3); if (sw0>0) hipiter(i);}
ropln() {clep('m'); neisum(8*BROW,AL,1);}
roplo() {co=nibbl(*r_pc++);}
roplp() {videodot(199-(int)(nu1),BORG+ct2,1+ct2%3); ct2=(100+ct2+1)%100;}
roplr() {ranmf(100,nibbl(*r_pc++),0,2);}
roplt() {twoblockfreq(100);}
roplx() {engen(*r_pc++);}
roplz() {clep(*r_pc++);}

ropua() {psstrip(ct0); ct0=(ct0+1)%3;}
ropub() {pl=nibbl(*r_pc++);}
ropud() {scanaij(ct1/3,ct1%3,1+ct2%3); ct1=(ct1+1)%9;}
ropue() {aijpanel(ct1/3,ct1%3,3,1+ct2%3); ct1=(ct1+1)%9;}
ropug() {retgen(1+ct2%3);}
ropuk() {neicon();}
ropuo() {dn=nibbl(*r_pc++);}
ropuq() {cubch(8);}
ropur() {ranmf(100,nibbl(*r_pc++),1,2);}
roput() {nutoto((int)r_dblpar); totoasc(); runu();}

/* ----------------------------------------------------------------- */

/* identify the current REC program (in panel E) */
recdi(n) int n; {
clep('e');
videocursor(0,EROW,0); printf(" f4 executes ed. program; f5, demo"); 
videocursor(0,EROW+1,0); printf("%0.40s",&drectabl[n]);
}

/* end rec-lcau24.c */
